using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Text;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class CallBack1 : System.Web.UI.Page , ICallbackEventHandler
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //Write JavaScript to the document.
        registerJScript();
        
        //Assign the Text Box Value to the Arugments to be posted back.
        string argument = "document.getElementById('" + TextBox1.ClientID + "').value";

        //retrieve the javascript method call declaration generated for us
        string scriptDeclaration = this.ClientScript.GetCallbackEventReference(this, argument, "FetchCustomerDetails", "null", "ErrorCallback", false);

        //Wire up Call back event two the onClick on the button.
        this.Button1.Attributes.Add("onclick", scriptDeclaration + "; return false;");
        //this.TextBox1.Attributes.Add("onchange", scriptDeclaration + ";return true;");

    }
    internal void registerJScript()
    {
        StringBuilder jscript = new StringBuilder();
        jscript.Append("<script language=\"javascript\">");
        //If an exception occurs on the server display the error message to the user.
        jscript.Append("function ErrorCallback(message){");
        jscript.Append("alert('An error occurred on the server:'\n + message);}");

        //Assign the Data returned from the server to the DIV section called UserControlHolder
        jscript.Append(" function FetchCustomerDetails(result, context){");
        jscript.Append("document.all['UserControlHolder'].innerHTML = result;}");
                
        jscript.Append("</script>");

        //REgister the the Javascript, this method will prevent the Script from been registered more than once,
        //Note : The Key parameter must be unique to each block of JavaScript you wish to register.
        Page.RegisterClientScriptBlock("CallbackScript", jscript.ToString());
    }


    #region ICallbackEventHandler Members
    private string _arguments = null;

    public string GetCallbackResult()
    {
        //Load the UserControl to display the customer information.
        CustomerDetails userContol = (CustomerDetails)LoadControl("~/Customerdetails.ascx");

        /*
         *  This little tick helps the JavaScript Challenged have cool webpages.
         *  Load the User Control, Fetch the Customer Details using the public method LoadCustomerDetails 
         *  on the UserControl.
         *  We then Render the Control using the RenderControl Method on the UserControl.
         *  Tip : This Method is available on all WebControls.
         *  We use the StringWriter to return the HTML Rendered from the UserControl.         
         */
        StringWriter writer = new StringWriter();
        HtmlTextWriter htmlText = new HtmlTextWriter(writer);
        userContol.LoadCustomerDetails(_arguments);
        userContol.RenderControl(htmlText);
        
        return writer.ToString(); 
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        //Save the Customer ID sent by the client.
        _arguments = eventArgument;
    }

    #endregion
}
